hwy::Rect Class Reference

`#include <image.h>`

## Public Member Functions

constexpr | Rect (size_t xbegin, size_t ybegin, size_t xsize_max, size_t ysize_max, size_t xend, size_t yend)
constexpr | Rect (size_t xbegin, size_t ybegin, size_t xsize, size_t ysize)
template<typename Image >
| Rect (const Image &image)
| Rect ()
| Rect (const Rect &)=default
Rect & | operator= (const Rect &)=default
Rect | Subrect (size_t xbegin, size_t ybegin, size_t xsize_max, size_t ysize_max)
template<typename T >
const T * | ConstRow (const Image< T > *image, size_t y) const
template<typename T >
T * | MutableRow (const Image< T > *image, size_t y) const
template<typename T >
const T * | ConstPlaneRow (const Image3< T > &image, size_t c, size_t y) const
template<typename T >
T * | MutablePlaneRow (Image3< T > *image, const size_t c, size_t y) const
template<class ImageT >
bool | IsInside (const ImageT &image) const
size_t | x0 () const
size_t | y0 () const
size_t | xsize () const
size_t | ysize () const

## Static Private Member Functions

static constexpr size_t | ClampedSize (size_t begin, size_t size_max, size_t end)

## Private Attributes

size_t | x0_
size_t | y0_
size_t | xsize_
size_t | ysize_

## Constructor & Destructor Documentation

## Rect() [1/5]

constexpr hwy::Rect::Rect | ( | size_t | xbegin,
|  | size_t | ybegin,
|  | size_t | xsize_max,
|  | size_t | ysize_max,
|  | size_t | xend,
|  | size_t | yend
| ) |  |

inline constexpr

## Rect() [2/5]

constexpr hwy::Rect::Rect | ( | size_t | xbegin,
|  | size_t | ybegin,
|  | size_t | xsize,
|  | size_t | ysize
| ) |  |

inline constexpr

## Rect() [3/5]

template<typename Image >

hwy::Rect::Rect | ( | const Image & | image | ) |

inline explicit

## Rect() [4/5]

hwy::Rect::Rect | ( |  | ) |

inline

Referenced by Subrect().

## Rect() [5/5]

hwy::Rect::Rect | ( | const Rect & |  | ) |

default

## Member Function Documentation

## ClampedSize()

static constexpr size_t hwy::Rect::ClampedSize | ( | size_t | begin,
|  | size_t | size_max,
|  | size_t | end
| ) |  |

inline static constexpr private

## ConstPlaneRow()

template<typename T >

const T * hwy::Rect::ConstPlaneRow | ( | const Image3< T > & | image,
|  | size_t | c,
|  | size_t | y
| ) |  | const

inline

References hwy::Image3< ComponentType >::ConstPlaneRow(), x0_, and y0_.

## ConstRow()

template<typename T >

const T * hwy::Rect::ConstRow | ( | const Image< T > * | image,
|  | size_t | y
| ) |  | const

inline

References hwy::Image< ComponentType >::ConstRow(), x0_, and y0_.

## IsInside()

template<class ImageT >

bool hwy::Rect::IsInside | ( | const ImageT & | image | ) | const

inline

References x0_, xsize_, y0_, and ysize_.

## MutablePlaneRow()

template<typename T >

T * hwy::Rect::MutablePlaneRow | ( | Image3< T > * | image,
|  | const size_t | c,
|  | size_t | y
| ) |  | const

inline

References hwy::Image3< ComponentType >::MutablePlaneRow(), x0_, and y0_.

## MutableRow()

template<typename T >

T * hwy::Rect::MutableRow | ( | const Image< T > * | image,
|  | size_t | y
| ) |  | const

inline

References hwy::Image< ComponentType >::MutableRow(), x0_, and y0_.

## operator=()

Rect & hwy::Rect::operator= | ( | const Rect & |  | ) |

default

## Subrect()

Rect hwy::Rect::Subrect | ( | size_t | xbegin,
|  | size_t | ybegin,
|  | size_t | xsize_max,
|  | size_t | ysize_max
| ) |  |

inline

References Rect(), x0_, xsize_, y0_, and ysize_.

## x0()

size_t hwy::Rect::x0 | ( |  | ) | const

inline

References x0_.

## xsize()

size_t hwy::Rect::xsize | ( |  | ) | const

inline

References xsize_.

## y0()

size_t hwy::Rect::y0 | ( |  | ) | const

inline

References y0_.

## ysize()

size_t hwy::Rect::ysize | ( |  | ) | const

inline

References ysize_.

## Member Data Documentation

## x0_

size_t hwy::Rect::x0_

private

Referenced by ConstPlaneRow(), ConstRow(), IsInside(), MutablePlaneRow(), MutableRow(), Subrect(), and x0().

## xsize_

size_t hwy::Rect::xsize_

private

Referenced by IsInside(), Subrect(), and xsize().

## y0_

size_t hwy::Rect::y0_

private

Referenced by ConstPlaneRow(), ConstRow(), IsInside(), MutablePlaneRow(), MutableRow(), Subrect(), and y0().

## ysize_

size_t hwy::Rect::ysize_

private

Referenced by IsInside(), Subrect(), and ysize().

The documentation for this class was generated from the following file:

- image.h